import 'package:templatr/src/widget.dart';

String button(String label, {
  String id,
  Map<String, String> style,
  Map<String, dynamic> attributes = const {},
  List<String> classes,
  String href,
  ButtonType type,
  bool loading = false,
  bool disabled = false,
  bool submit = false,
  String slot,
}) =>
    ElementWidget(
      'sl-button',
      id: id,
      style: style,
      classes: classes,
      attributes: {
        'href': href,
        'loading': loading,
        'disabled': disabled,
        'type': type?.name,
        'submit': submit,
        'slot': slot,
        ...attributes
      },

    )(label);

enum ButtonType {
  primary,
  success,
  info,
  warning,
  danger,
  text,
}

extension ButtonTypeName on ButtonType {
  String get name => toString().substring(toString().indexOf('.') + 1);
}
