import 'package:templatr/html.dart';
import 'package:templatr/widget.dart';
import 'package:test/test.dart';

void main() {
  test('element widget', () {
    var greeting = TemplateWidget((name) => span('Hi! My name is $name'));
    expect(greeting('John Doe'), '<span>Hi! My name is John Doe</span>');
  });

  test('element widget with id attribute', () {
    var greeting = TemplateWidget((name) => span('Hi! My name is $name', id: 'greeting'));
    expect(greeting('John Doe'), '<span id="greeting">Hi! My name is John Doe</span>');
  });

  test('element widget with style attribute', () {
    var greeting = TemplateWidget((name) => span('Hi! My name is $name', style: {'color': '#ff0000'}));
    expect(greeting('John Doe'), '<span style="color: #ff0000">Hi! My name is John Doe</span>');
  });

  test('element widget with classes attribute', () {
    var greeting = TemplateWidget((name) => span('Hi! My name is $name', classes: ['big', 'primary']));
    expect(greeting('John Doe'), '<span class="big primary">Hi! My name is John Doe</span>');
  });

  test('nested widgets', () {
    var greeting = TemplateWidget((name) => span('Hi! My name is $name'));
    var wrapper = TemplateWidget((name) => div(['== ${greeting(name)} ==']));
    expect(wrapper('John Doe'), '<div>== <span>Hi! My name is John Doe</span> ==</div>');
  });
}
